"{ Package: 'jv:calipel/s/benchmarks/game' }"!

!LargeInteger methodsFor:'bit operators'!

bitCount
    "Count the number of bits set to 1 in self"

    | bitCount |
    bitCount := 0.
    1 to: self digitLength do: [:i |
        bitCount := bitCount + (self digitAt: i) bitCount].
    ^bitCount

    "Created: / 10-06-2013 / 21:00:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LargeInteger methodsFor:'bit operators'!

bitsDo: aBlock
    | mask offset |
    1 to: self digitLength do: [:iByte |
        offset := iByte - 1 bitShift: 3.
        mask := self digitAt: iByte.
        [mask = 0]
            whileFalse:
                [aBlock value: mask lowBit + offset.
                mask := mask bitAnd: mask - 1]]

    "Created: / 10-06-2013 / 21:02:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallInteger methodsFor:'*CL-Benchmarks-Game-Meteor-bit manipulation'!

bitReverse: highBit 
    | v r s |
    highBit < self highBit ifTrue: [ self error: 'Not enough bits.' ].
    v := self.
    r := v bitAnd: 1.
    s := highBit - 1.
    [ v := v bitShift: -1.
    v = 0 ] whileFalse:
        [ r := r bitShift: 1.
        r := r bitOr: (v bitAnd: 1).
        s := s - 1 ].
    ^ r bitShift: s
! !

!SmallInteger methodsFor:'*CL-Benchmarks-Game-Meteor-bit manipulation'!

bitsDo: aBlock
    | mask |
    self < 0 ifTrue: [^self error: 'Cannot enumerate bits of a negative integer'].
    mask := self.
    [mask = 0]
        whileFalse:
            [aBlock value: mask lowBit.
            mask := mask bitAnd: mask - 1]
! !

!jv_calipel_s_benchmarks_game class methodsFor:'documentation'!

extensionsVersion_HG

    ^ '$Changeset: <not expanded> $'
! !
